## haskell-futhark 0.25.27

=== Makefile ===
# This Makefile mostly serves to abbreviate build commands that are
# unnecessarily obtuse or longwinded.  It depends on the underlying
# build tool (cabal) to actually do anything incrementally.
# Configuration is mostly read from cabal.project.

PREFIX?=$(HOME)/.local
INSTALLBIN?=$(PREFIX)/bin/futhark

UNAME:=$(shell uname)

# Disable all implicit rules.
.SUFFIXES:

.PHONY: all configure build install docs check check-commit clean

all: build

configure:
	cabal update
	cabal configure

configure-profile:
	cabal configure --enable-profiling --profiling-detail=toplevel-functions

build:
	cabal build

install: build
	install -d $(shell dirname $(INSTALLBIN))
	install "$$(cabal -v0 list-bin exe:futhark)" $(INSTALLBIN)

docs:
	cabal haddock \
		--enable-documentation \
		--haddock-html \
		--haddock-options=--show-all \
		--haddock-options=--quickjump \
		--haddock-options=--show-all \
		--haddock-options=--hyperlinked-source

check:
	tools/style-check.sh src unittests

check-commit:
	tools/style-check.sh $$(git diff-index --cached --ignore-submodules=all --name-status HEAD | awk '$$1 != "D" { print $$2 }')

unittest:
	cabal run unit

clean:
	cabal clean

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Futhark.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Futhark.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Futhark"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Futhark"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

## haskell-futhark 0.25.15

=== debian/changelog ===
haskell-futhark (0.25.15-3) unstable; urgency=medium

  * Sourceful upload for GHC 9.6

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 09 Oct 2024 11:51:19 +0300

haskell-futhark (0.25.15-2) unstable; urgency=medium

  * Add missing build deps alex and happy (Closes: #1069980)

 -- Kari Pahula <kaol@debian.org>  Sun, 28 Apr 2024 19:15:28 +0300

haskell-futhark (0.25.15-1) unstable; urgency=low

  * Initial release (Closes: #906850)

 -- Kari Pahula <kaol@debian.org>  Fri, 26 Apr 2024 14:38:16 +0300

=== debian/control ===
Source: haskell-futhark
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Kari Pahula <kaol@debian.org>,
Priority: optional
Section: haskell
Rules-Requires-Root: no
Build-Depends: debhelper (>= 10),
 haskell-devscripts-minimal | haskell-devscripts (>= 0.13),
 python3-sphinx,
 alex,
 happy,
 cdbs,
 ghc (>= 9.6),
 ghc-prof,
 libghc-aeson-dev (>= 2.0.0.0),
 libghc-aeson-prof,
 libghc-ansi-terminal-dev (>= 0.6.3.1),
 libghc-ansi-terminal-prof,
 libghc-base16-bytestring-dev,
 libghc-base16-bytestring-prof,
 libghc-blaze-html-dev (>= 0.9.0.1),
 libghc-blaze-html-prof,
 libghc-bmp-dev (>= 1.2.6.3),
 libghc-bmp-prof,
 libghc-bytestring-to-vector-dev (>= 0.3.0.1),
 libghc-bytestring-to-vector-prof,
 libghc-cmark-gfm-dev (>= 0.2.1),
 libghc-cmark-gfm-prof,
 libghc-cryptohash-md5-dev,
 libghc-cryptohash-md5-prof,
 libghc-directory-tree-dev (>= 0.12.1),
 libghc-directory-tree-prof,
 libghc-dlist-dev (>= 0.6.0.1),
 libghc-dlist-prof,
 libghc-fgl-dev,
 libghc-fgl-prof,
 libghc-fgl-visualize-dev,
 libghc-fgl-visualize-prof,
 libghc-file-embed-dev (>= 0.0.14.0),
 libghc-file-embed-prof,
 libghc-free-dev (>= 5.1.10),
 libghc-free-prof,
 libghc-futhark-data-dev (>= 1.1.0.0),
 libghc-futhark-data-prof,
 libghc-futhark-manifest-dev (>= 1.4.0.0),
 libghc-futhark-manifest-prof,
 libghc-futhark-server-dev (>= 1.2.2.1),
 libghc-futhark-server-prof,
 libghc-githash-dev (>= 0.1.6.1),
 libghc-githash-prof,
 libghc-half-dev (>= 0.3),
 libghc-half-prof,
 libghc-language-c-quote-dev (>= 0.12),
 libghc-language-c-quote-prof,
 libghc-lens-dev,
 libghc-lens-prof,
 libghc-mainland-pretty-dev (>= 0.7.1),
 libghc-mainland-pretty-prof,
 libghc-megaparsec-dev (>= 9.0.0),
 libghc-megaparsec-prof,
 libghc-mwc-random-dev,
 libghc-mwc-random-prof,
 libghc-neat-interpolation-dev (>= 0.3),
 libghc-neat-interpolation-prof,
 libghc-parallel-dev (>= 3.2.1.0),
 libghc-parallel-prof,
 libghc-prettyprinter-dev (>= 1.7),
 libghc-prettyprinter-prof,
 libghc-prettyprinter-ansi-terminal-dev (>= 1.1),
 libghc-prettyprinter-ansi-terminal-prof,
 libghc-process-extras-dev (>= 0.7.2),
 libghc-process-extras-prof,
 libghc-random-dev (>= 1.2.0),
 libghc-random-prof,
 libghc-regex-tdfa-dev (>= 1.2),
 libghc-regex-tdfa-prof,
 libghc-srcloc-dev (>= 0.4),
 libghc-srcloc-prof,
 libghc-statistics-dev,
 libghc-statistics-prof,
 libghc-temporary-dev,
 libghc-temporary-prof,
 libghc-terminal-size-dev (>= 0.3),
 libghc-terminal-size-prof,
 libghc-vector-dev (>= 0.12),
 libghc-vector-prof,
 libghc-versions-dev (>= 6.0.0),
 libghc-versions-prof,
 libghc-zlib-dev (>= 0.6.3.0),
 libghc-zlib-prof,
 hipcc [amd64 arm64 ppc64el] <!nocheck>,
Build-Depends-Indep: ghc-doc,
 libghc-aeson-doc,
 libghc-ansi-terminal-doc,
 libghc-base16-bytestring-doc,
 libghc-blaze-html-doc,
 libghc-bmp-doc,
 libghc-bytestring-to-vector-doc,
 libghc-cmark-gfm-doc,
 libghc-cryptohash-md5-doc,
 libghc-directory-tree-doc,
 libghc-dlist-doc,
 libghc-fgl-doc,
 libghc-fgl-visualize-doc,
 libghc-file-embed-doc,
 libghc-free-doc,
 libghc-futhark-data-doc,
 libghc-futhark-manifest-doc,
 libghc-futhark-server-doc,
 libghc-githash-doc,
 libghc-half-doc,
 libghc-language-c-quote-doc,
 libghc-lens-doc,
 libghc-mainland-pretty-doc,
 libghc-megaparsec-doc,
 libghc-mwc-random-doc,
 libghc-neat-interpolation-doc,
 libghc-parallel-doc,
 libghc-prettyprinter-doc,
 libghc-prettyprinter-ansi-terminal-doc,
 libghc-process-extras-doc,
 libghc-random-doc,
 libghc-regex-tdfa-doc,
 libghc-srcloc-doc,
 libghc-statistics-doc,
 libghc-temporary-doc,
 libghc-terminal-size-doc,
 libghc-vector-doc,
 libghc-versions-doc,
 libghc-zlib-doc,
Standards-Version: 4.7.0
Homepage: https://futhark-lang.org
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/haskell-futhark
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/haskell-futhark]
X-Description: library files for for Futhark programming language
 Futhark is a small programming language designed to be compiled to
 efficient parallel code. It is a statically typed, data-parallel, and
 purely functional array language in the ML family, and comes with a
 heavily optimising ahead-of-time compiler that presently generates
 GPU code via CUDA, HIP and OpenCL, although the language itself is
 hardware-agnostic.

Package: libghc-futhark-dev
Architecture: any
Depends: ${haskell:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: ${haskell:Recommends},
Suggests: ${haskell:Suggests},
Conflicts: ${haskell:Conflicts},
Provides: ${haskell:Provides},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: libghc-futhark-prof
Architecture: any
Depends: ${haskell:Depends},
 ${misc:Depends},
Recommends: ${haskell:Recommends},
Suggests: ${haskell:Suggests},
Conflicts: ${haskell:Conflicts},
Provides: ${haskell:Provides},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: libghc-futhark-doc
Architecture: all
Section: doc
Depends: ${haskell:Depends},
 ${misc:Depends},
Recommends: ${haskell:Recommends},
Suggests: ${haskell:Suggests},
Conflicts: ${haskell:Conflicts},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: futhark
Architecture: any
Section: devel
Depends: ${haskell:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ${haskell:Recommends},
 futhark-doc,
Suggests:
 ${haskell:Suggests},
 hipcc,
Conflicts: ${haskell:Conflicts},
Provides: ${haskell:Provides},
Description: optimising compiler for Futhark programming language
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: futhark-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
Description: Futhark User's Guide
 ${haskell:LongDescription}
 .
 HTML documentation for the Futhark programming language.

## haskell-futhark 0.25.23

=== debian/changelog ===
haskell-futhark (0.25.23-2) unstable; urgency=medium

  * Add build-essential as dependency for autopkgtest tests

 -- Kari Pahula <kaol@debian.org>  Fri, 01 Nov 2024 07:36:07 +0200

haskell-futhark (0.25.23-1) unstable; urgency=medium

  * New upstream package
  * Remove patch to increase the amount of output futhark test --notty
    made
  * Patch futhark test to abort a test on a timeout
  * Use autopkgtest for tests

 -- Kari Pahula <kaol@debian.org>  Wed, 30 Oct 2024 17:25:16 +0200

=== debian/tests/control ===
Tests: multicore
Depends: build-essential, futhark

Tests: opencl
Depends: build-essential, futhark, pocl-opencl-icd, ocl-icd-opencl-dev

Tests: hip
Depends: build-essential, futhark, hipcc, rocminfo
Restrictions: skippable, needs-sudo
Architecture: amd64 arm64 ppc64el

## haskell-futhark 0.25.26

=== debian/changelog ===
haskell-futhark (0.25.26-1) unstable; urgency=medium

  * New upstream package
  * Set tests as flaky for now

 -- Kari Pahula <kaol@debian.org>  Sun, 02 Feb 2025 20:34:44 +0200

=== debian/tests/control ===
Tests: multicore
Depends: build-essential, futhark
Restrictions: flaky

Tests: opencl
Depends: build-essential, futhark, pocl-opencl-icd, ocl-icd-opencl-dev
Restrictions: flaky

Tests: hip
Depends: build-essential, futhark, hipcc, rocminfo
Restrictions: skippable, needs-sudo, flaky
Architecture: amd64 arm64 ppc64el

## haskell-futhark 0.25.27

=== debian/changelog ===
haskell-futhark (0.25.27-1) unstable; urgency=medium

  * New upstream package
  * Restrict OpenCL test to only architectures which have pocl built
    successfully

 -- Kari Pahula <kaol@debian.org>  Mon, 10 Feb 2025 20:49:09 +0200

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,8 @@
  libghc-aeson-prof,
  libghc-ansi-terminal-dev (>= 0.6.3.1),
  libghc-ansi-terminal-prof,
+ libghc-async-dev (>= 2.2),
+ libghc-async-prof,
  libghc-base16-bytestring-dev,
  libghc-base16-bytestring-prof,
  libghc-blaze-html-dev (>= 0.9.0.1),
@@ -41,11 +43,11 @@
  libghc-file-embed-prof,
  libghc-free-dev (>= 5.1.10),
  libghc-free-prof,
- libghc-futhark-data-dev (>= 1.1.0.0),
+ libghc-futhark-data-dev (>= 1.1.1.0),
  libghc-futhark-data-prof,
- libghc-futhark-manifest-dev (>= 1.4.0.0),
+ libghc-futhark-manifest-dev (>= 1.5.0.0),
  libghc-futhark-manifest-prof,
- libghc-futhark-server-dev (>= 1.2.2.1),
+ libghc-futhark-server-dev (>= 1.2.3.0),
  libghc-futhark-server-prof,
  libghc-githash-dev (>= 0.1.6.1),
  libghc-githash-prof,
@@ -89,10 +91,10 @@
  libghc-versions-prof,
  libghc-zlib-dev (>= 0.6.3.0),
  libghc-zlib-prof,
- hipcc [amd64 arm64 ppc64el] <!nocheck>,
 Build-Depends-Indep: ghc-doc,
  libghc-aeson-doc,
  libghc-ansi-terminal-doc,
+ libghc-async-doc,
  libghc-base16-bytestring-doc,
  libghc-blaze-html-doc,
  libghc-bmp-doc,

=== debian/tests/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Tests: opencl
 Depends: build-essential, futhark, pocl-opencl-icd, ocl-icd-opencl-dev
 Restrictions: flaky
+Architecture: amd64 arm64 armel armhf i386
 
 Tests: hip
 Depends: build-essential, futhark, hipcc, rocminfo

=== debian/watch ===
# The hackage release doesn't include test files or Python setup
version=4
https://github.com/diku-dk/futhark/tags .*/v?(\d.*)@ARCHIVE_EXT@

## haskell-futhark 0.25.32

=== Makefile ===
--- 
+++ 
@@ -39,13 +39,34 @@
 		--haddock-options=--hyperlinked-source
 
 check:
-	tools/style-check.sh src unittests
+	tools/style-check.sh src src-testing
 
 check-commit:
 	tools/style-check.sh $$(git diff-index --cached --ignore-submodules=all --name-status HEAD | awk '$$1 != "D" { print $$2 }')
 
 unittest:
-	cabal run unit
+	cabal run unit -- --hide-successes
+
+test-oclgrind:
+	cabal run -- futhark test tests -c --backend=opencl --exclude=compiled --exclude=no_oclgrind --cache-extension=cache --pass-option=--build-option=-O0 --runner=tools/oclgrindrunner.sh
+
+test-t:
+	cabal run -- futhark test tests -t
+
+test-c:
+	cabal run -- futhark test tests -c --backend=c --no-tuning
+
+test-ispc:
+	cabal run -- futhark test -c --backend=ispc tests --no-tuning
+
+test-multicore:
+	cabal run -- futhark test tests -c --backend=multicore --no-tuning
+
+test-interpreter:
+	cabal run -- futhark test tests -i
+
+test-structure:
+	cabal run -- futhark test tests -s
 
 clean:
 	cabal clean

=== docs/requirements.txt ===
pyyaml>=4.2b1
sphinx>=4.2.0

=== tests_lib/c/Makefile ===
FUTHARK_BACKEND ?= c

ifeq ($(FUTHARK_BACKEND),opencl)
CFLAGS=-O3 -std=c99
LDFLAGS=-lm -lOpenCL
else ifeq ($(FUTHARK_BACKEND),multicore)
CFLAGS=-O3 -std=c99
LDFLAGS=-lm
else ifeq ($(FUTHARK_BACKEND),ispc)
CFLAGS=-O3 -std=c99
LDFLAGS=-lm
ISPCFLAGS=--woff --pic --addressing=64
else ifeq ($(FUTHARK_BACKEND),cuda)
CFLAGS=-O3 -std=c99
LDFLAGS=-lm -lcuda -lcudart -lnvrtc
else ifeq ($(FUTHARK_BACKEND),hip)
CFLAGS=-O3 -std=c99
LDFLAGS=-lm -lamdhip64 -lhiprtc
else
CFLAGS=-O3 -std=c99
LDFLAGS=-lm
endif

.SECONDARY:

.PHONY: test clean

test: $(patsubst %.fut, do_test_%, $(wildcard *.fut))

do_test_%: test_%
	./validatemanifest.py ../../docs/manifest.schema.json $*.json
	./test_$*

test_%: test_%.c %.o
  ifeq ($(FUTHARK_BACKEND),ispc)
	gcc -o $@ $^ $(patsubst test_%, %_ispc.o, $@) -Wall -Wextra -pedantic -std=c99 $(LDFLAGS) -lpthread
  else
	gcc -o $@ $^ -Wall -Wextra -pedantic -std=c99 $(LDFLAGS) -lpthread
  endif

%.o: %.c
  ifeq ($(FUTHARK_BACKEND),ispc)
	ispc -o $*_ispc.o $*.kernels.ispc $(ISPCFLAGS)
  endif
	gcc $*.c -c $(CFLAGS)

%.c: %.fut
	futhark $(FUTHARK_BACKEND) --library $^

clean:
	rm -rf $(patsubst %.c, %, $(wildcard test_*.c)) *.h *.o *.ispc $(patsubst %.fut, %.c, $(wildcard *.fut))

=== tests_lib/javascript/Makefile ===
FUTHARK_BACKEND ?= wasm

.PHONY: test clean

test: do_test_a do_test_array

do_test_%: test_%.js %.mjs
	node --experimental-wasm-simd test_$*.js

%.mjs: %.fut
	futhark $(FUTHARK_BACKEND) --library $^

clean:
	rm -rf *.c *.h *.class.js *.wasm *.mjs

=== tests_lib/python/Makefile ===
FUTHARK_BACKEND ?= python

.PHONY: test clean

test: do_test_a do_test_g

do_test_%: test_% %.py
	./test_$*

test_%: %.py

%.py: %.fut
	futhark $(FUTHARK_BACKEND) --library $^

clean:
	rm -rf test_? ?.c ?.h

=== tools/release/skeleton/Makefile ===
#  High-performance purely functional data-parallel array programming on the GPU
# See LICENSE file for copyright and license details.

include config.mk

BINARIES=bin/*

all:
	@echo "This is a precompiled binary distribution of Futhark - no building necessary."
	@echo "But you may want to check out config.mk to ensure that 'make install' installs to the right place."

install:
	@echo \# Installing executable files to ${PREFIX}/bin
	@mkdir -p ${PREFIX}/bin/
	install bin/* ${PREFIX}/bin/
	@echo \# Installing manual page to ${MANPREFIX}/man1
	@mkdir -p ${MANPREFIX}/man1/
	@echo \# Installing manpages to ${MANPREFIX}/man1/
	install -D -m 644 share/man/man1/* ${MANPREFIX}/man1/


.PHONY: all install

=== debian/changelog ===
haskell-futhark (0.25.32-3) unstable; urgency=medium

  * Build using dh-haskell
  * Sourceful upload for GHC 9.10

 -- Scott Talbert <swt@techie.net>  Wed, 11 Feb 2026 23:10:16 -0500

haskell-futhark (0.25.32-2) unstable; urgency=medium

  * Add missing build-deps libghc-tasty-{dev,prof},
    libghc-tasty-hunit-{dev,prof} and libghc-tasty-quickcheck-{dev,prof}.

 -- Kari Pahula <kaol@debian.org>  Fri, 22 Aug 2025 20:12:40 +0300

haskell-futhark (0.25.32-1) unstable; urgency=medium

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Mon, 18 Aug 2025 19:09:54 +0300

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Priority: optional
 Section: haskell
 Rules-Requires-Root: no
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
  haskell-devscripts-minimal | haskell-devscripts (>= 0.13),
  python3-sphinx,
  alex,
  happy,
- cdbs,
- ghc (>= 9.6),
+ dh-sequence-haskell,
+ ghc (>= 9.10),
  ghc-prof,
  libghc-aeson-dev (>= 2.0.0.0),
  libghc-aeson-prof,
@@ -29,6 +29,8 @@
  libghc-bytestring-to-vector-prof,
  libghc-cmark-gfm-dev (>= 0.2.1),
  libghc-cmark-gfm-prof,
+ libghc-criterion-dev,
+ libghc-criterion-prof,
  libghc-cryptohash-md5-dev,
  libghc-cryptohash-md5-prof,
  libghc-directory-tree-dev (>= 0.12.1),
@@ -43,7 +45,7 @@
  libghc-file-embed-prof,
  libghc-free-dev (>= 5.1.10),
  libghc-free-prof,
- libghc-futhark-data-dev (>= 1.1.1.0),
+ libghc-futhark-data-dev (>= 1.1.2.0),
  libghc-futhark-data-prof,
  libghc-futhark-manifest-dev (>= 1.5.0.0),
  libghc-futhark-manifest-prof,
@@ -81,6 +83,12 @@
  libghc-srcloc-prof,
  libghc-statistics-dev,
  libghc-statistics-prof,
+ libghc-tasty-dev,
+ libghc-tasty-prof,
+ libghc-tasty-hunit-dev,
+ libghc-tasty-hunit-prof,
+ libghc-tasty-quickcheck-dev,
+ libghc-tasty-quickcheck-prof,
  libghc-temporary-dev,
  libghc-temporary-prof,
  libghc-terminal-size-dev (>= 0.3),
@@ -131,7 +139,7 @@
  libghc-vector-doc,
  libghc-versions-doc,
  libghc-zlib-doc,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://futhark-lang.org
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/haskell-futhark
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/haskell-futhark]

=== debian/rules ===
#!/usr/bin/make -f

execute_after_dh_auto_build-arch:
	cd docs; make man

execute_after_dh_auto_build-indep:
	cd docs; make html

execute_after_dh_install-indep:
	rm -f debian/libghc-futhark-doc/usr/share/doc/libghc-futhark-doc/html/CHANGELOG.md.gz

%:
	dh $@
